# include <stdio.h>
# include <math.h>
# include <malloc.h>
# define TWOPI 6.283185317958

struct cmplx {
	float re;
	float im;
};
int sinwave(long nread,struct cmplx *ftdat);

main()
{
	long nread=2048;
	struct cmplx *ftdat;
	int i;
	FILE *fp;

	if( (fp = fopen("sin.out","wb")) == NULL){
		fprintf(stderr,"cannot open sin.out\n");
		exit(1);
	}
	ftdat = (struct cmplx *) malloc(3000*sizeof(struct cmplx));
	sinwave(nread, ftdat);
	printf("%f %f\n", ftdat[1].re, ftdat[1].im);
	fwrite(ftdat,8,2048,fp);
	return(0);
}

/*
Fill the real part of ftdat with a sine wave to test the fft routine.
*/
int
sinwave(long nread,struct cmplx *ftdat)
{
	long i;
	double freq = 2000.; /* Hz */
	double omega;
	double t,dt;

	dt = 1./32000.;

	
	omega = TWOPI*freq;
	for(i = 0; i < nread; i++){
		t = (double)i*dt;
		ftdat[i].re = sin(omega*t);
		ftdat[i].im = 0.;
	}
	return(0);
}
