# include <stdio.h>
# define TRUE	1
# define FALSE	0
/*
Compute the Doppler frequency by looking halfway between the
+.5 and -.5 down points of the spectrum.
*/

main(argc,argv)
int argc;
char *argv[];
{
	float x[2048],y[2048];
	float frq,ydiff;
	double df,finit,fstart;
	int i,npts,ifrq;
	int iinit;
	float bandfrq();
	double f;
	char wd[100];
	FILE *fpout;
	int iret;

	int started;
	int c;

	if((fpout = fopen("spc.out","w")) == NULL){
		fprintf(stderr,"error: %s cannot open file %s\n",argv[0],
			"spc.out");
		exit(-1);		
	}
	started = FALSE;
	do{
		c = getchar();
		if(c != 'a') flushline();
		else{
			scanf("%lf %lf",&df,&finit);
			started = TRUE;
			flushline();
		}
	} while(!started);

/* Go until you hit the spectrum data */
	while(scanf("%f",&y[i]) != 1) flushline();


/* skip over all data until the primary spectrum */
	fstart = -16000.;
	i = 1;
	do{
		scanf("%f",&y[0]);
		f = finit + df*(double)i;
		i++;
	} while(f < fstart);

	npts = (int)(32000./df);
	x[0] = f;
	fprintf(fpout,"%g %g\n",x[0],y[0]);
	for(i = 1; i < npts; i++){
		scanf("%f",&y[i]);
		x[i] = fstart + (float)i*df;
		fprintf(fpout,"%g %g\n",x[i],y[i]);
	}
	frq = bandfrq(x,y,npts,df,&iret);
	printf("%f %f %g\n",frq-800,frq+800,y[iret]*1.2);
}

float
bandfrq(x,y,npts,df,iret)
float x[],y[];
int npts;
double df;
int *iret;
{
	float ypk;
	float ythresh;
	float fneg,fpos,fdop;
	int i,ipk,ineg,ipos;
/* find the peak */
	ypk = y[0];
	ipk = 0;
	for(i = 0; i < npts; i++){
		if(y[i] > ypk){
			ypk = y[i];
			ipk = i;
		}
	}
	fdop = x[ipk];
	*iret = ipk;
	return(fdop);
}

flushline()
{
	int c;

	while( (c = getchar()) != '\n'){
		if(c == EOF){
			fprintf(stderr,"no data found in input file\n");
			exit(-1);
		}
	}
	return(0);
}
