# include <stdio.h>
# include <math.h>
# define FALSE	0
# define TRUE	1
# define TWOPI 6.28318530717958647688

# define SWAP(a,b) tempr=(a); (a)=(b); (b)=tempr
int wrt_fftdat(float fftdat[],long ntotal,float dt);
int pwrof2(long n);

/*
If isign = 1, this routine replaces data by its discrete Fourier
transform.  If isign = -1, it replaces data by nn times its inverse
discrete Fourier transform.  The array data is complex and of length
nn, input as a real array data[1...2*nn].  The integer nn must be a
power of 2.
*/
int
four1(data,nn,isign)
float *data;
long nn,isign;
{
	long n,mmax,m,j,istep,i;
	double wtemp,wr,wpr,wpi,wi,theta;
	float tempr,tempi;
	float dt;

	if(!pwrof2(nn)){
		fprintf(stderr,"four1 fft error: nn is not a power of 2\n");
		return(FALSE);
	}
	dt = 1./32000.;
/*	wrt_fftdat(data,nn,dt); */

	n = nn << 1;
	j = 1;
	for(i = 1; i < n; i += 2){
		if( j > i ){
			SWAP(data[j],data[i]);
			SWAP(data[j+1],data[i+1]);
		}
		m = n >> 1;
		while(m >= 2 && j > m){
			j -= m;
			m >>= 1;
		}
		j += m;
	}
	mmax = 2;
	while( n > mmax){
		istep = 2*mmax;
		theta = TWOPI/(isign*mmax);
		wtemp = sin(0.5*theta);
		wpr = -2.0*wtemp*wtemp;
		wpi = sin(theta);
		wr = 1.0;
		wi = 0.0;
		for( m = 1; m < mmax; m += 2){
			for(i = m; i <= n; i += istep){
				j = i + mmax;
				tempr = wr*data[j] - wi*data[j+1];
				tempi = wr*data[j+1]  + wi*data[j];
				data[j] = data[i] - tempr;
				data[j+1] = data[i+1] - tempi;
				data[i] += tempr;
				data[i+1] += tempi;
			}
			wr = (wtemp=wr)*wpr - wi*wpi + wr;
			wi = wi*wpr + wtemp*wpi + wi;
		}
		mmax  = istep;
	}
	return(TRUE);
}


pwrof2(n)
long n;
/* check to see if n is an integer power of 2 */
{
	long nn;
	long i;

	nn = n;
	i = 0;
	while(nn > 1){
		nn >>= 1;
		i++;
	}
	nn <<= i;
	if(nn != n){
		return(FALSE);
	}
	return(TRUE);
	
}
int
wrt_fftdat(float fftdat[],long ntotal,float dt)
{
	long i;

	printf("# input data real\n");
	for(i = 0; i < ntotal; i++){
		printf("%f %f\n",(float)i*dt,fftdat[2*i]);
	}
	printf("# input data imaginary\n");
	for(i = 0; i < ntotal; i++){
		printf("%f %f\n",(float)i*dt,fftdat[2*i+1]);
	}
	return(0);
}
