# include <stdio.h>
# define NPTS 1024
# define NPTSO2 512
# define FORWARD 1
# define INVERSE -1

struct cmplx {
	float re;
	float im;
} ftdat[2048];

main(argc,argv)
int argc;
char *argv[];
{
	int i,n,ntotal,sf;
	float dum;
	FILE *fp;
	float *fftdat;
	int stat;

/* open the file that holds the filter coefficients */
	if((fp = fopen("filter.coe","r")) == NULL){
		fprintf(stderr,"error: %s cannot open file %s\n",
			argv[0],"filter.coe");
		exit(-1);
	}
	ntotal = NPTS;
/* initialize ftdat */
	for(i = 0; i < ntotal; i++){
		ftdat[i].re = 0.;
		ftdat[i].im = 0.;
	}

/* read the filter coefficients */
	i = 0;
	while( (sf = fscanf(fp,"%g %g",&dum,&ftdat[i].re)) == 2){
		i++;
	}
	n = i;
/* transform */
	fftdat = (float *) ftdat;
	stat = four1(fftdat-1,ntotal,INVERSE);
	for(i = 0; i < ntotal; i++){
		printf("%f %f\n",ftdat[i].re,ftdat[i].im);
	}

	exit(0);
}

int
getpwrof2(n)
int n;
/* make ntotal an integer power of 2 */
{
	int nn;
	int i;
	int ntotal;

	nn = n;
	i = 0;
	while(nn > 1){
		nn >>= 1;
		i++;
	}
	nn <<= i;
	if(nn != n){
		ntotal = nn<<1;
	} else ntotal = n;
	return(ntotal);
}
