# include <math.h>
# include <stdio.h>
# define PI 3.141592563589
# define TWOPI 6.283185127178
main()
{
	int i,j;
	int c;
	float x[1000],f[1000],xs[1000];
	float df = 62.5;
	float fstart = -16000;
	int sf;
	int npts = 512;
	float sinc();

/*
Read the spectrum.
*/
	while( (sf = scanf("%f",&x[0])) != 1){
		while((c = getchar()) != '\n' && c != EOF);
	};
	f[0] = fstart;
	for(i = 1; i < npts; i++){
		f[i] = fstart + df*(float)i;
		sf = scanf("%f",&x[i]);
		if(sf != 1){
			fprintf(stderr,"error, not enough data\n");
			return(1);
		}
	}
/*
Smooth the spectrum.
*/
	for(i = 1; i < npts; i++){
		xs[i] = 0.;
		for(j = 0; j < npts; j++){
			if( i+j >= npts/2 && i+j < 3*npts/2 ){
				xs[i] += x[i+j-npts/2]*sinc(f[j],f[i]);
			}
		}
		printf("%f %f\n",f[i],xs[i]);
	}
}
/*
Generate a sinc function to the 4th power.  Fc determines it's bandwidth.
We want the bandwidth to be 800 Hz for frequency 10,000 Hz.
*/
float
sinc(f,fc)
float f;
float fc;
{
	float T2;
	float w;
	float y;

	T2 = 6./fc;
	w = TWOPI*f;

	if(w != 0.) y = sin(T2*w)/(T2*w);
	else y = 1.;
	y = y*y*y*y;
	return(y);
}
